<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\DashboardService;

class DashboardController extends FMCrud{
   protected $DashboardService;
   
    public function __construct($crudService, $environment, DashboardService $DashboardService) {
        parent::__construct($crudService, $environment);
        $this->DashboardService = $DashboardService;
    }
  
  public function getDadosLimpezaFinalizada(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosLimpezaFinalizada();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }
  
  public function getDadosTarefaAtrasada(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaAtrasada();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }

  public function getDadosTarefaConcluida(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaConcluida();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }
  
  public function getDadosProgress(DTO\Request $request, DTO\Response $response) {
    $dadosProgress = $this->DashboardService->getDadosProgress();
    $dtsVal = new DataSet('dados', $dadosProgress);
    $response->addDataSet($dtsVal);
  }
}
?>