<?php
namespace FM\Service;

use FM\Factory\DashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardService {
    
    protected $DashboardFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (DashboardFactory $DashboardFactory, Environment $Environment, NewCode $newCode) {
        $this->DashboardFactory  = $DashboardFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }
    
    // responsável por retornar os dados de limpeza finalizada do dashboard
    public function getDadosLimpezaFinalizada(){
        
        $selectDadosLimpezaFinalizada = $this->DashboardFactory->getDadosLimpezaFinalizada();
        
        return $selectDadosLimpezaFinalizada;
    }
    
    // responsável por retornar os dados de tarefa atrasada do dashboard
    public function getDadosTarefaAtrasada(){
        
        $selectDadosTarefaAtrasada = $this->DashboardFactory->getDadosTarefaAtrasada();
        
        return $selectDadosTarefaAtrasada;
    }
    
    // responsável por retornar os dados de tarefa finalizada do dashboard
    public function getDadosTarefaConcluida(){
        $selectTarefaConcluida = $this->DashboardFactory->getDadosTarefaConcluida();
        return $selectTarefaConcluida;
    }
    
    public function getDadosProgress(){
        $countTarefasConcluidas = $this->DashboardFactory->countTarefasConcluidas();
        $countTarefas  = $this->DashboardFactory->countTarefas();
        return[$countTarefasConcluidas,$countTarefas];
    }
    
}