CREATE OR REPLACE TRIGGER PEDIDO_OL_EXPEDICAO
AFTER INSERT
ON ITEMPEDEXOL FOR EACH ROW
DECLARE
V_CDFILIOPELOG    ITEMSOLI.CDFILIOPELOG%TYPE;
V_CDCLIENTE       PARAMPEDIDO.CDCLIENTE%TYPE;
V_NRPEDIDO        PEDIDO.NRPEDIDO%TYPE;
V_PXM_NRPEDIDO    VARCHAR2(20);
V_NOVO_NRPEDIDO   PEDIDO.NRPEDIDO%TYPE;
V_CDPRECOBASE     PRECOBASE.CDPRECOBASE%TYPE;
V_CDPRECOBASEPED  PRECOBASE.CDPRECOBASE%TYPE;
V_CDMODPGTO       PARAMPEDIDO.CDMODPGTO%TYPE;
V_CDVENDEDOR      PARAMPEDIDO.CDVENDEDOR%TYPE;
V_NMOPERADOR      OPERADOR.NMOPERADOR%TYPE;
V_CDOPELANPED     PEDIDO.CDOPELANPED%TYPE;
V_NRITEMPED       ITEMPEDIDO.NRITEMPED%TYPE;
V_NOVO_NRITEMPED  ITEMPEDIDO.NRITEMPED%TYPE;
V_VRPREUNITPED    ITEMPEDIDO.VRPREUNITPED%TYPE;
V_TP_CUSTO        FLOAT;
V_CUSTO           FLOAT;
V_IDLANCPED       PARAMPEDIDO.IDLANCPED%TYPE;
V_IDSITPEDIDO     PEDIDO.IDSITPEDIDO%TYPE;
V_IDSITITEMPED    ITEMPEDIDO.IDSITITEMPED%TYPE;
V_CDARVPROD       PRODUTO.CDARVPROD%TYPE;
V_NMPRODUTO       PRODUTO.NMPRODUTO%TYPE;
V_CDFORMPGTO      MODPGTO.CDFORMPGTO%TYPE;
V_IDTPFORPGTPED   PEDIDO.IDTPFORPGTPED%TYPE;
V_NRDIAPGFIXPED   PEDIDO.NRDIAPGFIXPED%TYPE;
V_NRPARCPGTOPED   PEDIDO.NRPARCPGTOPED%TYPE;
V_CDTIPORECE      MODPGTO.CDTIPORECE%TYPE;
V_DTENTPED        PEDIDO.DTENTPED%TYPE;

BEGIN
   /*DADOS DO PEDIDO*/
   SELECT MAX(P.CDFILIOPELOG)
     INTO V_CDFILIOPELOG
     FROM PEDIDOEXOL P
    WHERE P.CDFILDEST  = :NEW.CDFILDEST
      AND P.CDFILLANC  = :NEW.CDFILLANC
      AND P.NRPEDEXOL  = :NEW.NRPEDEXOL;

   SELECT MAX(P.CDCLIENTE),
          MAX(P.CDMODPGTO),
          MAX(P.CDVENDEDOR),
          MAX(IDLANCPED)
     INTO
        V_CDCLIENTE,
        V_CDMODPGTO,
        V_CDVENDEDOR,
        V_IDLANCPED
     FROM PARAMPEDIDO P
    WHERE CDFILIAL = V_CDFILIOPELOG;

   SELECT MAX(P.NRPEDIDO) INTO V_NRPEDIDO
     FROM PEDIDO P, ITEMPEDIDO IP
    WHERE P.CDFILIAL    = IP.CDFILIAL
      AND P.NRPEDIDO    = IP.NRPEDIDO
      AND P.CDFILIAL    = V_CDFILIOPELOG
      AND P.CDCLIENTE   = V_CDCLIENTE
      AND P.CDFILIALPED = :NEW.CDFILDEST
      AND P.IDSITPEDIDO IN ('1','2')
      AND (INSTR(IP.DSITEMPED, V_CDFILIOPELOG||:NEW.CDFILLANC||:NEW.CDFILDEST||:NEW.NRPEDEXOL) > 0);

   IF V_IDLANCPED IS NULL THEN
      V_IDLANCPED := '1';
   END IF;

   IF V_IDLANCPED = '1' THEN
      V_IDSITPEDIDO  := '1';
      V_IDSITITEMPED := '1';
   END IF;

   IF V_IDLANCPED = '2' THEN
      V_IDSITPEDIDO  := '2';
      V_IDSITITEMPED := '2';
   END IF;

   IF V_IDLANCPED = '3' THEN
      V_IDSITPEDIDO  := '2';
      V_IDSITITEMPED := '3';
   END IF;

   IF V_NRPEDIDO IS NULL THEN
      NOVO_CODIGO_SC('PEDIDO', V_PXM_NRPEDIDO, 1);
      V_NOVO_NRPEDIDO := SUBSTR(V_PXM_NRPEDIDO, 11, 10);

      NMUSUARIO(V_NMOPERADOR);

      SELECT MAX(CDOPERADOR) INTO V_CDOPELANPED
        FROM OPERADOR
       WHERE NMOPERADOR LIKE V_NMOPERADOR;

      IF V_CDOPELANPED IS NULL THEN
         SELECT MAX(CDOPERADOR) INTO V_CDOPELANPED
           FROM OPERADOR;
      END IF;

      SELECT MAX(CDFORMPGTO), MAX(IDTPFORPGTOMOD), MAX(CDTIPORECE), MAX(NRDIAPGFIXMOD), MAX(NRPARCPGTOMOD)
        INTO  V_CDFORMPGTO, V_IDTPFORPGTPED, V_CDTIPORECE, V_NRDIAPGFIXPED, V_NRPARCPGTOPED
        FROM MODPGTO
       WHERE CDMODPGTO = V_CDMODPGTO;

      SELECT TRUNC(SYSDATE)
        INTO V_DTENTPED
        FROM DUAL;

      SELECT MAX(CDPRECOBASE)
        INTO V_CDPRECOBASE
        FROM PRECOBASECLI
       WHERE CDCLIENTE = V_CDCLIENTE
         AND IDPRBASEPRIN = 'S';

      IF V_CDPRECOBASE IS NULL THEN
         SELECT MAX(CDPRECOBASE)
           INTO V_CDPRECOBASE
           FROM PRECOUTI
          WHERE PRECOUTI.CDMODPGTO = V_CDMODPGTO
            AND PRECOUTI.CDFILIAL  = V_CDFILIOPELOG;
      END IF;

      INSERT INTO PEDIDO
             (CDFILIAL, NRPEDIDO, IDSITPEDIDO, CDCLIENTE, IDPRIOPED, DTPEDIDO, DTENTPED,
             CDFORMPGTO, IDTPFORPGTPED, NRDIAPGFIXPED, NRPARCPGTOPED,  CDPRECOBASE, CDTIPORECE, CDVENDEDOR,
             CDMODPGTO, DTHRLANPED, CDOPELANPED, IDPEDIDOIMPR, IDTIPOPEDIDO, IDORIGPED, CDFILIALPED)
      VALUES (V_CDFILIOPELOG, V_NOVO_NRPEDIDO, V_IDSITPEDIDO, V_CDCLIENTE, '3',  V_DTENTPED, :NEW.DTPROGENPEOL,
             V_CDFORMPGTO, V_IDTPFORPGTPED, V_NRDIAPGFIXPED, V_NRPARCPGTOPED, V_CDPRECOBASE, V_CDTIPORECE, V_CDVENDEDOR,
             V_CDMODPGTO, SYSDATE, V_CDOPELANPED, 'N', '1', '9', :NEW.CDFILDEST);

      IF V_IDTPFORPGTPED = 'V' THEN
             INSERT INTO PRAZOPGTOPED (CDFILIAL, NRPEDIDO, NRDIASPGTOPED, VRPERCPGTOPED)
             SELECT V_CDFILIOPELOG, V_NOVO_NRPEDIDO, NRDIASMODPGTO, VRPERCMODPGTO
               FROM PRAZOMODPGTO
              WHERE CDMODPGTO = V_CDMODPGTO;
      END IF;
   ELSE
      V_NOVO_NRPEDIDO := V_NRPEDIDO;
   END IF;

   /*DADOS DO ITEM DO PEDIDO*/

   SELECT MAX(NRITEMPED)
     INTO V_NRITEMPED
     FROM ITEMPEDIDO
    WHERE CDFILIAL     = V_CDFILIOPELOG
      AND NRPEDIDO     = V_NRPEDIDO;

   IF V_NRITEMPED IS NULL THEN
      V_NOVO_NRITEMPED := '0000000001';
   ELSE
      SELECT LPAD((TO_CHAR(TO_NUMBER(V_NRITEMPED) + 1)), 10, '0') INTO V_NOVO_NRITEMPED FROM DUAL;
   END IF;
   IF V_NRPEDIDO IS NOT NULL THEN
      SELECT MAX(CDPRECOBASE)
        INTO V_CDPRECOBASEPED
        FROM PRECOBASECLI
       WHERE CDCLIENTE = V_CDCLIENTE
         AND IDPRBASEPRIN = 'S';
   ELSE
      V_CDPRECOBASEPED := V_CDPRECOBASE;
   END IF;

   IF V_CDPRECOBASEPED IS NULL THEN
      SELECT MAX(CDPRECOBASE)
        INTO V_CDPRECOBASEPED
        FROM PRECOUTI
       WHERE PRECOUTI.CDMODPGTO = V_CDMODPGTO
         AND PRECOUTI.CDFILIAL  = V_CDFILIOPELOG;
   END IF;

   SELECT NVL(MAX(VRITEPREBASE), (-1)) INTO  V_VRPREUNITPED
     FROM ITEMPREBASE
    WHERE (CDPRODUTO   = :NEW.CDPRODUTO)
      AND (CDPRECOBASE = V_CDPRECOBASEPED)
      AND (TRUNC(SYSDATE) BETWEEN DTINIVALIPB AND NVL(DTFIMVALIPB, (SYSDATE+1)));

   IF NVL(V_VRPREUNITPED, -1) > 0 THEN
      INSERT INTO ITEMPEDIDO
             (CDFILIAL, NRPEDIDO, NRITEMPED, IDSITITEMPED, CDPRODUTO,
             QTITEMPED, VRPREUNITPED, QTEXPITEMPED, DTENTITPED, DSITEMPED)
      VALUES (V_CDFILIOPELOG, V_NOVO_NRPEDIDO, V_NOVO_NRITEMPED, V_IDSITITEMPED, :NEW.CDPRODUTO,
             :NEW.QTPROGENPEOL, V_VRPREUNITPED, 0, :NEW.DTPROGENPEOL,
              'OL -->'||' Site Destino: '||:NEW.CDFILDEST||' - Pedido OL: '||:NEW.NRPEDEXOL||' - '||V_CDFILIOPELOG||:NEW.CDFILLANC||:NEW.CDFILDEST||:NEW.NRPEDEXOL||:NEW.CDMARCA||:NEW.CDPRODUTO);
   ELSE
      DELETE FROM PEDIDO
      WHERE CDFILIAL = :NEW.CDFILLANC
        AND NRPEDIDO = V_NOVO_NRPEDIDO
        AND NOT EXISTS (SELECT 1
                          FROM ITEMPEDIDO
                         WHERE ITEMPEDIDO.CDFILIAL = PEDIDO.CDFILIAL
                           AND ITEMPEDIDO.NRPEDIDO = PEDIDO.NRPEDIDO);
      SELECT MAX(CDARVPROD), MAX(NMPRODUTO)
        INTO V_CDARVPROD, V_NMPRODUTO
        FROM PRODUTO
       WHERE CDPRODUTO = :NEW.CDPRODUTO;

      IF V_IDTPFORPGTPED = 'V' THEN
         DELETE PRAZOPGTOPED
          WHERE CDFILIAL = V_CDFILIOPELOG
            AND NRPEDIDO = V_NOVO_NRPEDIDO;
      END IF;

      raise_application_error(-20501,'No es posible importar un pedido para el producto '||RTRIM(V_CDARVPROD)||' '||RTRIM(V_NMPRODUTO)||' porque ste est con precio base igual a cero.', False);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PEDIDO_OL_EXPEDICAO','5.07.000'); END;
/


