import Vue from 'vue';
import Router from 'vue-router';
import { ZdPage } from '@zeedhi/vue';

Vue.use(Router);

const router = new Router({
  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
    {
      path: '/',
      name: 'home',
      component: () => import('./views/Home.vue'),
    },
    {
      name: 'NãoConformidades',
      path: '/Analise_nao_conformidedade',
      component: ZdPage,
      props: {
        path: 'FCMAnaliseNaoConformidade',
        local: true,
      },
    },
    {
      name: 'Tarefas',
      path: '/Tarefas',
      component: ZdPage,
      props: {
        path: 'FCMTarefas',
        local: true,
      },
    },
    {
      name: 'Tarefa',
      path: '/Tarefa',
      component: ZdPage,
      props: {
        path: 'tarefas',
        local: true,
      },
    },
    {
      name: 'Dashboard',
      path: '/dashboard',
      component: ZdPage,
      props: {
        path: 'dashboard',
        local: true,
      },
    },
    {
      name: 'Cadastramento_tarefas',
      path: '/Cadastramento',
      component: ZdPage,
      props: {
        path: 'cadastramentoTarefas',
        local: true,
      },
    },
    {
      name: 'test',
      path: '/test',
      component: ZdPage,
      props: {
        path: 'test',
        local: true,
      },
    },
    {
      path: '/zeedhi',
      name: 'zeedhi',
      component: ZdPage,
      props: () => ({
        path: 'zeedhi',
        local: true,
      }),
    },
    {
      path: '/login',
      name: 'login',
      component: ZdPage,
      props: () => ({
        path: 'login',
        local: true,
      }),
    },
    {
      path: '*',
      component: ZdPage,
      props: {
        path: 'notfound',
        local: true,
      },
    },
    {
      path: '/tipoLocal',
      component: ZdPage,
      props: {
        path: 'tipoLocal',
        local: true,
      },
    },
    {
      name: 'Novo Checklit',
      path: '/cadastroNovoChecklist',
      component: ZdPage,
      props: {
        path: 'cadastroNovoChecklist',
        local: true,
      },
    },
    {
      path: '/localAtendimento',
      component: ZdPage,
      props: {
        path: 'localAtendimento',
        local: true,
      },
    },
    {
      path: '/localAtendimento/:nr',
      component: ZdPage,
      props: {
        path: 'localAtendimento',
        local: true,
      },
    },
    {
      path: '/checklist',
      component: ZdPage,
      props: {
        path: 'checklist',
        local: true,
      },
    },
    {
      path: '/dashboard',
      component: ZdPage,
      props: {
        path: 'dashboard',
        local: true,
      },
    },
    {
      path: '/editChecklist/:nr',
      component: ZdPage,
      props: {
        path: 'editChecklist',
        local: true,
      },
    },
    {
      path: '/gerenciarLocais',
      component: ZdPage,
      props: {
        path: 'gerenciarLocais',
        local: true,
      },
    },
    {
      path: '/agrupamentoSimples/:bloco',
      component: ZdPage,
      props: {
        path: 'agrupamentoSimples',
        local: true,
      },
    },
    {
      path: '/funcionarios',
      component: ZdPage,
      props: {
        path: 'funcionarios',
        local: true,
      },
    },
    {
      path: '/perfilDeAcesso',
      component: ZdPage,
      props: {
        path: 'perfilDeAcesso',
        local: true,
      },
    },
    {
      path: '/vistorias',
      component: ZdPage,
      props: {
        path: 'vistorias',
        local: true,
      },
    },
    {
      path: '/vistorias/detalhes/:id',
      component: ZdPage,
      props: {
        path: 'vistoriaDetalhes',
        local: true,
      },
    },
  ],
});

router.beforeEach((to, from, next) => {
  if (!localStorage.getItem('UserLogado') && (to.fullPath !== '/login')) {
    next('/login');
  } else {
    next();
  }
});

export const { VUE_APP_BASE_URL } = process.env;

export const getRoutePath = () => {
  const { currentRoute } = router;
  const { path } = currentRoute;
  return path;
};

export const getRouteParams = () => {
  const { currentRoute } = router;
  const { params } = currentRoute;
  return params;
};

export default router;
